<?php
/*
 * FUNCIONES COMUNES PARA PROCEDIMIENTOS PAYPAL
 * actualizaventaspaypal()
*/

defined( 'ABSPATH' ) || exit;
if(is_multisite()){
	$GLOBALS['pp_soy_servidor']=soy_servidor(get_current_blog_id());
}

$options = get_option( '_invoices_options' );

$pm=get_paypal_payment_method();

if ($pm=='checkout'){
	$GLOBALS['user_email_name']='liveAPIUsername';
	$GLOBALS['_user_email_name']='_liveAPIUsername';
	$GLOBALS['paypal_cpt']='paypals';
	$GLOBALS['info_paypal_field']='woocommerce_ppec_paypal_settings';
	$GLOBALS['paypalinputname']='woocommerce_ppec_paypal_api_username';
	$GLOBALS['user_in_settings']='api_username';
}

if ($pm=='payments'){
	$GLOBALS['user_email_name']='liveEmailAddress';
	$GLOBALS['_user_email_name']='_liveEmailAddress';
	$GLOBALS['paypal_cpt']='paypalpayments';
	$GLOBALS['info_paypal_field']='woocommerce-ppcp-settings';
	$GLOBALS['paypalinputname']='ppcp-merchant_email_production';
	$GLOBALS['user_in_settings']='api_username';//cambiar esto
}
$GLOBALS['pp_server_id']=get_main_shop(); //obtener con get_option('pp_server_id'); aplicado en el site_id=1

if ($GLOBALS['pp_soy_servidor']){
	include('paypal-cpt-single.php'); //crea paypals custom type
	include('paypal-configuration.php');//parametros de configuracion para el cpt
}// fin de si pp_servidor == S

include('paypal-return-paypals-table.php'); //una page con un shortcode que devuelva un json con los paypals
 
if ($options['pp_cliente']<>'N'){
	include('paypal-client-functions.php'); //mi_script, funcion_paypals, paypal_page_template, lista_paypals_page
	include('paypal-show-widget.php');//agregar_widget_red, mostrar_widget_red, agregar_widget_pais, mostrar_widget_pais
	include('paypal-update-sales.php');// cliente-servidor -> paypal_update_sales
	
}// fin de si pp_cliente <> N

//include('paypal-transision-multi-single.php');
$depu[]='entrada';
update_blog_option(1,'_depu',$depu);

////////////////////////////////////////////////////////////////////
///////////////////ACTUALIZA VENTA PAYPAL //////////////////////////
////////////////////////////////////////////////////////////////////

//actualizacion del monto de una venta en el paypal activo
function actualizaventapaypal($order_id)
{
	$order = new WC_Order( $order_id );
	//$paymentdate = $order->get_date_paid(); //2023-02-24T20:49:16+00:00
	$paypal_receiver = get_post_meta($order_id,'paypal_receiver');
	$total = $order->get_total();
	$url_pais = 'softwarelicenses.net/uk';//esto es solo un ejemplo para ubicarme
	paypal_update_sales($paypal_receiver, $total, $url_pais);
}

add_action( 'woocommerce_order_status_completed', 'actualizaventapaypal'  );

//liveApiUsername		woocommerce_ppec_paypal_settings	
//liveEmailAddress		woocommerce-ppcp-settings

////////////////////////////////////////////////////////////////////
///////////////////FUNCIONES COMUNES////////////////////////////////
////////////////////////////////////////////////////////////////////

//devolver el correo configurado para paypal en la variable $def segun el método de pago
function paypal_username($user_email = 'user')
{
	global $paypal_usernameemail, $paypal_user_field;
	$options = get_option( 'woocommerce_paypal_settings' );
	if($options['enabled']=="yes"){
		$def=$options['receiver_email'];
	}else{
		$options1 = get_option( 'woocommerce_ppec_paypal_settings' );
		if($options1['enabled']=="yes"){
			//$title="<p style='font-size:9px;color:gray;'>Paypal checkout</p>";
			$def=$options1['api_username'];
			if($user_email=='email'){
				$def=str_replace("_api1.","@",$options1['api_username']).$title;
			}
			$paypal_user_field="_liveAPIUsername";
		}else{
			$options2 = get_option( 'woocommerce-ppcp-settings' ); 
			if ($options2['enabled']==TRUE){
				//$title="<p style='font-size:9px;color:gray;'>Paypal</p>";
				$def=$options2['merchant_email_production']; 
				$paypal_usernameemail=$options2['merchant_email_production'];
				$paypal_user_field="_liveEmailAddress";
			}else{
				$def="Paypal receiver was not detected."; 
			}//fin de woocommerce-ppcp-settings
		}
	}// fin de else
	return $def;
}// function paypal_email end

function get_main_shop() //actualizado, saca _pp_server_id de wp_options
{
	$q="SELECT option_value FROM wp_options WHERE option_name = '_pp_server_id'";
	return $GLOBALS['wpdb']->get_var($q);
}

//se utiliza para el cliente
function get_paypal_payment_method()
{
	$options = get_option( 'woocommerce_paypal_settings' );
	if($options['enabled']=="yes"){
		$def="Woocommerce";
	}else{
		$options1 = get_option( 'woocommerce_ppec_paypal_settings' );
		if($options1['enabled']=="yes"){
			$def="checkout";
		}else{
			$options2 = get_option( 'woocommerce-ppcp-settings' ); 
			if ($options2['enabled']==TRUE){
				$def="payments"; 
			}else{
				$def="Paypal receiver was not detected."; 
			}//fin de woocommerce-ppcp-settings
		}
	}// fin de else
	return $def;
}// function get_paypal_payment_method() end

//BORRAR buscar valor en wp_x_waovalues
function get_paypal_date_changed123($prefix, $nombre)
{
	return get_option($nombre);
}// fin de funcion

// Actualización de wp_x_posts post_type = 'paypals' estado = enrevision y paypallifetimesales = 0
// cuando exista una actualizacion en wp_x_options option_name = 'woocommerce_ppec_paypal_settings' o 'woocommerce-ppcp-settings' 

function paypal_status_update_multiselect($newusername,$oldusername) //LA LOGICA YA ESTA LIMPIA
{
	global $wpdb;

	//$r = get_option( $GLOBALS['info_paypal_field'] );
	//$option_name=$GLOBALS['user_in_settings'];
	//$oldusername=$r{$option_name};

	if ($newusername<>$oldusername){
	//if (TRUE){
		//ESTOY EN UN PAIS CON site_id_pais

		$site_id_pais = get_current_blog_id();
		//cambio al servidor !!!!
		switch_to_blog(get_option('_pp_server_id'));
			$posts=$wpdb->prefix.'posts';
			$postmeta=$wpdb->prefix.'postmeta';
			//buscamos el paypal_id del paypal con username = $oldusername
			$q = "SELECT post_id FROM  ".$postmeta." WHERE meta_key = '".$GLOBALS['_user_email_name']."' AND meta_value = '".$oldusername."'";
			$paypal_id = $wpdb->get_var($q);
			//extraemos el metadato _ppactiveinsites
			$ppactiveinsites = get_post_meta($paypal_id,'_ppactiveinsites',true);
			if(!is_array($ppactiveinsites)){$ppactiveinsites=array();}
			//eliminamos el site_id_pais actual del array
			if (($clave = array_search($site_id_pais, $ppactiveinsites)) !== false) {
				unset($ppactiveinsites[$clave]);
			}
			//actualizamos el metadato actualizado
			update_post_meta($paypal_id,'_ppactiveinsites',$ppactiveinsites);
			//si ya no hay paises activos, colocamos el paypal En_revision
			if(count($ppactiveinsites)==0){
				$wpdb->update($postmeta, array('meta_value'=>'En_revision'), array('post_id' => $paypal_id, 'meta_key' => '_ppstatus'));
			}else{
				add_action( 'admin_notices', 'my_alert1');
			}

			//buscamos el paypal_id del paypal con username = $newusername
			$q = "SELECT post_id FROM  ".$postmeta." WHERE meta_key = '".$GLOBALS['_user_email_name']."' AND meta_value = '".$newusername."'";
			$paypal_id = $wpdb->get_var($q);
			//extraemos el metadato _ppactiveinsites
			$ppactiveinsites = get_post_meta($paypal_id,'_ppactiveinsites',true);
			if (empty($ppactiveinsites)){$ppactiveinsites=array();}
			$ppactiveinsites[]=$site_id_pais;
			update_post_meta($paypal_id,'_ppactiveinsites',$ppactiveinsites);

			//insertamos el site_id_pais actual en el array
			//actualizamos el metadato actualizado
			//actualizamos estado del paypal entrante a Activo y ppactivesales en 0 
			$wpdb->update($postmeta, array('meta_value'=>'Activo'), array('post_id' => $paypal_id, 'meta_key' => '_ppstatus'));
			//ponemos en cero las ventas desde la activacion actual
			$wpdb->update($postmeta, array('meta_value'=>'0'), array('post_id' => $paypal_id, 'meta_key' => '_ppactivesales'));
			
			//registramos la fechahora del cambio
			$options=$wpdb->prefix.'options';
			//$wpdb->update($options,);
			update_option('_paypalupdatedate',date("d-m-Y h:i:s"));

			$oldpaypal=get_option('_oldpaypals');
			//$insert = array('paypal'=>$oldusername,'date_changed'=>date("d-m-Y h:i:s"));
			$insert = $oldusername."*".date("d-m-Y h:i:s")."|";
			$oldpaypal.=$insert;
			//update_option('_oldpaypals',json_encode($oldpaypals));
			update_option('_oldpaypals',$oldpaypal);
//			update_post_meta(55801,"_depu",$depu);
		restore_current_blog(); //vuelvo al shop del pais
	}
}

function paypal_status_update($newusername,$oldusername) //LA LOGICA YA ESTA LIMPIA
{
	global $wpdb;

	//if ($newusername<>$oldusername){
	if (TRUE){
		//ESTOY EN UN PAIS CON site_id_pais

		$site_id_pais = get_current_blog_id();
		//cambio al servidor !!!!
		switch_to_blog(get_option('_pp_server_id'));
			$posts=$wpdb->prefix.'posts';
			$postmeta=$wpdb->prefix.'postmeta';

			// NEWEST! jalamos el paypal_old_id de la tabla options del sitio pais. Misma es grabada para uso posterior 
			$paypal_old_id = get_option('_pp_active_id'); //en este pais 
			if(is_bool($paypal_old_id)){
				// NEW! buscamos el paypal_id del paypal con username = $oldusername que corresponda al pais NUEVO QUERY 
				// Mantengo esto por compatibilidad
				$country=$_POST['blog_id']; // jala el pais en que estamos
				//$q = "SELECT post_id FROM  ".$postmeta." WHERE meta_key = '".$GLOBALS['_user_email_name']."' AND meta_value = '".$oldusername."'";
				$q = "SELECT P.post_id
						FROM wp_postmeta P LEFT JOIN wp_postmeta Q ON Q.post_id = P.post_id AND Q.meta_key = '_forsite'
						WHERE P.meta_key = '".$GLOBALS['_user_email_name']."'
						  AND P.meta_value = '".$oldusername."'
						  AND Q.meta_value = ".$country;
				$paypal_old_id = $wpdb->get_var($q); // 
			}

			//actualizamos el metadato con valor vacio
			update_post_meta($paypal_old_id,'_ppactiveinsites','');
			//Colocamos el paypal En_revision
			$wpdb->update($postmeta, array('meta_value'=>'En_revision'), array('post_id' => $paypal_old_id, 'meta_key' => '_ppstatus'));

			//buscamos el paypal_id del paypal con username = $newusername
			//$q = "SELECT post_id FROM  ".$postmeta." WHERE meta_key = '".$GLOBALS['_user_email_name']."' AND meta_value = '".$newusername."'";
			//$paypal_id = $wpdb->get_var($q);

			// NEW! capturamos el paypal ID directamente
			$paypal_new_id = $_POST['paypal_id'];
			//actualizamos el metadato con valor del site_id
			update_post_meta($paypal_new_id,'_ppactiveinsites',$site_id_pais);
			//Colocamos el paypal como Activo
			$wpdb->update($postmeta, array('meta_value'=>'Activo'), array('post_id' => $paypal_new_id, 'meta_key' => '_ppstatus'));
			//ponemos en cero las ventas desde la activacion actual
			$wpdb->update($postmeta, array('meta_value'=>'0'), array('post_id' => $paypal_new_id, 'meta_key' => '_ppactivesales'));
			
			//registramos la fechahora del cambio
			$options=$wpdb->prefix.'options';
			//$wpdb->update($options,);
			update_option('_paypalupdatedate',date("d-m-Y h:i:s"));

			$oldpaypal=get_option('_oldpaypals');
			//$insert = array('paypal'=>$oldusername,'date_changed'=>date("d-m-Y h:i:s"));
			$insert = $oldusername."*".date("d-m-Y h:i:s")."|";
			$oldpaypal.=$insert;
			//update_option('_oldpaypals',json_encode($oldpaypals));
			update_option('_oldpaypals',$oldpaypal);
			update_option('_pp_active_id',$paypal_new_id); // guardo en opciones del pais el 
//			update_post_meta(55801,"_depu",$depu);
		restore_current_blog(); //vuelvo al shop del pais
	}
}

if (isset($_POST['newusername']) AND $_POST['newusername']<>""){
	$newusername = $_POST['newusername'];
	$oldusername = $_POST['oldusername'];
	$options = get_option('_paypal_options');
	$m = $options['multiple_countries']=='M'?true:false;
	if($m){
		paypal_status_update_multiselect($newusername,$oldusername);
	}else{
		paypal_status_update($newusername,$oldusername);
	}
}

function my_alert1(){
	$message = "<p>El paypal cambiado, a&uacute; est&aacute; activo en otros shops!</p><p>Se debe revisar en cada uno de ellos.</p>";	
	echo "<div class='notice notice-alert id-dismissible'>";	
	echo $message;	
	echo "</div>";	
}

// para uso posterior

function soy_servidor($id){
	//$ppserverid=get_blog_option1(1,'_pp_server_id');
	return $id == get_blog_option1(1,'_pp_server_id')?true:false;
}

function get_paypal_options(){
	$main=get_main_shop();
	return get_blog_option($main, "_paypal_options");
}

function get_blog_option1($blog_id,$option_name){
	$table=get_prefix($blog_id)."options";
	$q="SELECT option_value FROM ".$table." WHERE option_name = '".$option_name."'";
	return $GLOBALS['wpdb']->get_var($q);
}

function get_blog_postmeta1($blog_id,$post_id,$meta_key){
	$table=get_prefix($blog_id)."options";
	$q="SELECT meta_value FROM ".$table." WHERE meta_key = '".$meta_key."'";
	return $GLOBALS['wpdb']->get_var($q);
}

function update_blog_option1($blog_id,$option_name,$option_value){
	$table=get_prefix($blog_id)."options";
	//$q="UPDATE ".$table." SET option_value = '".$option_value."' WHERE option_name = '".$option_name."'";
	return $GLOBALS['wpdb']->update($table, array('option_value' => $option_value), array('option_name' => $option_name));
}

function update_blog_postmeta1($blog_id,$post_id,$meta_key,$meta_value){
	$table=get_prefix($blog_id)."options";
	//$q="UPDATE ".$table." SET meta_value = ".$meta_value."WHERE meta_key = '".$meta_key."'";
	return $GLOBALS['wpdb']->update($table, array('meta_value' => $meta_value), array('meta_key' => $meta_key));
}

function get_prefix($blog_id){
	return $blog_id==1?"wp_":"wp_".$blog_id."_";
}

function manage_columns( $columns, $post_type = 'paypals') { //2nd param not passed for pages
if ( in_array( $post_type, array( 'paypals' ) ) ) {
  // This is only for posts and pages, 'if (in_array(...))' just illustrates how.
  unset( $columns['date']);
  //unset( $columns['author']);
  //unset( $columns['comments']);
  //unset( $columns['wp-statistics-post-hits-hide']);
  unset( $columns['hits-hide']);
}
return $columns;
}

add_action( 'manage_posts_columns', 'manage_columns', 10, 2 );

